extern "C" {
#include <lua.h>
#include <lualib.h>
#include <lauxlib.h>
}

#include <cassert>
#include <iostream>
using namespace std;

#include "utils/c++/LuaUtils.hpp"
#include "utils/c++/OrbUtils.hpp"

#include "ApplicationRepositoryStub.hpp"


  //----------------------------------------------------------------------
  ApplicationRepositoryStub::ApplicationRepositoryStub(lua_State * aState,
                                                       const string & aAppReposIor):state(aState){
    //FIXME: This assumes that state ALREADY loaded the IDL for the GRM. Due to
    //O2's current design it is not possible to load the GRM IDL separately.
    OrbUtils::instantiateProxy (state, aAppReposIor,
                               "IDL:interfaces/ApplicationRepository:1.0",
                               "appReposProxy");

  }

  //----------------------------------------------------------------------
  string ApplicationRepositoryStub::registerApplication(const string & appPath){

     int stackTop = lua_gettop(state);
     lua_getglobal(state, "appReposProxy");
     lua_pushstring(state, "registerApplication");
     lua_gettable(state, -2);
     lua_getglobal(state, "appReposProxy");
     LuaUtils::openFileForRead(state, appPath);
     LuaUtils::readFullFile(state);
     lua_call(state, 2, 1);//in:proxy & file out: appId
     string appId(lua_tostring(state, -1));
     lua_pop(state, 2);//appId & appReposProxy
     LuaUtils::closeDefaultFile(state);
     assert(stackTop == lua_gettop(state));
     return appId;

  }

  //----------------------------------------------------------------------
  string ApplicationRepositoryStub::downloadApplication(const string & appId){

     int stackTop = lua_gettop(state);
     lua_getglobal(state, "appReposProxy");//appReposProxy on stack
     lua_pushstring(state, "getApplicationBinary");  // modified by Vidal 02/2005
     lua_gettable(state, -2);
     lua_getglobal(state, "appReposProxy");
     lua_pushlstring(state, appId.c_str(),appId.length());

     if (lua_pcall(state, 2, 1, 0) != 0){
       cerr << "--> " << appId << " <--" << endl;
          cerr << "[ERROR] ApplicationRepositoryStub::downloadApplication -> Lua error: "
          << lua_tostring(state, -1) << endl;
         lua_pop(state, 1);
     }
     int appIndex = lua_gettop(state);
     std::string value( lua_tostring(state,-1),lua_strlen(state,-1));
     lua_pop(state, 2);//removes appReposProxy,app
     assert(stackTop == lua_gettop(state));
     return value;

  }


