
extern "C" {
#include <lua.h>
#include <lualib.h>
#include <lauxlib.h>
}


#include "utils/c++/LuaUtils.hpp"
#include "utils/c++/OrbUtils.hpp"
#include <assert.h>

#include "ArsmStub.hpp"
#include "ArscImpl.hpp"
#include "MessagePacket.hpp"
class MessagePacket;



  //----------------------------------------------------------------------
  ArsmStub::ArsmStub(lua_State * aState, const string & arsmIor):state(aState){
    //FIXME: This assumes that state ALREADY loaded the IDL for the arsm. Due to
    //O2's current design it is not possible to load the GRM IDL separately.
    OrbUtils::instantiateProxy (state, arsmIor, "interfaces::Arsm", "arsmProxy");

  }
 //-----------------------------------------------------------------------
  ArsmStub::ArsmStub(){
  	
  }
MessagePacket ArsmStub::sendReceiveToken(MessagePacket msgOut)
 {
	int stackTop = lua_gettop(state);
	lua_getglobal(state, "arsmProxy");
	lua_pushstring(state, "sendReceiveStream");
	lua_gettable(state, -2);
	lua_getglobal(state, "arsmProxy");
	//Creates a table with value field
	lua_newtable(state);
	LuaUtils::setFieldOnTable(state,std::string("value"),msgOut.getStream(),-1);
     	if (lua_pcall(state, 2, 1, 0) != 0){
 		lua_getglobal(state, "tostring");
      		lua_insert(state, -2);
      		lua_pcall(state, 1, 1, 0);
      		cerr << "[ERROR] ArsmStub::sendReceiveToken->Lua error: "
           	<< lua_tostring(state, -1) << endl;
      		lua_pop(state, 1);
 	}
	MessagePacket msgIn=MessagePacket(LuaUtils::getStringFromTable(state,"value"));
    	lua_pop(state,2);//Removes arsmProxy and  value from stack
    	assert(stackTop == lua_gettop(state));
	return  msgIn;
}

 void finish(char * id,char * sign)
 {
 	
 	
 }
MessagePacket ArsmStub::test(MessagePacket msgGSS)
 {
    int stackTop = lua_gettop(state);
    std::string id;
    lua_getglobal(state, "arsmProxy");
    lua_pushstring(state, "test");
    lua_gettable(state, -2);
    lua_getglobal(state, "arsmProxy");
    //Creates a table with MessagePacketGSS
    lua_newtable(state);
    LuaUtils::setFieldOnTable(state,"value",msgGSS.getStream(),-1);
    if (lua_pcall(state, 2, 1, 0) != 0){
  		cerr << "[ERROR] ArsmStub::teste->Lua error: "
       << lua_tostring(state, -1) << endl;
  		lua_pop(state, 1);
	}
	MessagePacket msg = MessagePacket(LuaUtils::getStringFromTable(state,"value"));
	lua_pop(state,2); //Removes arsmProxy from stack
	assert(stackTop == lua_gettop(state));
	return  msg;
}

void  ArsmStub::finish(string id)
 {
 	MessagePacket msgFinish = MessagePacket(id);
 	int stackTop = lua_gettop(state);
        lua_getglobal(state, "arsmProxy");
        lua_pushstring(state, "finish");
        lua_gettable(state, -2);
        lua_getglobal(state, "arsmProxy");
        //Creates a table with MessagePacket
        lua_newtable(state);
        LuaUtils::setFieldOnTable(state,"value",msgFinish.getStream(),-1);
	    if (lua_pcall(state, 2, 0, 0) != 0){
	       cerr << "[ERROR] ArsmStub::finish->Lua error: "
	           << lua_tostring(state, -1) << endl;
	           lua_pop(state, 1);
	     }
      	lua_pop(state,1); //Removes arsmProxy from stack
	assert(stackTop == lua_gettop(state)); 	
    
}


