#startservices.sh - starts the various InteGrade modules
#Author: Jose de Ribamar Braga Pinheiro Junior
#Modified by: Andrei Goldchleger, Ricardo Luiz de Andrade Abrantes
#

#!/bin/bash
#set -x
wait=3
in=false
secureAppRepos=false
# Environment Variables
export IG_HOME=/tmp/integrade/
export ANT_HOME=/home/pub/ant-1.6.5/
export JACORB_HOME=/tmp/JacORB-2.2.3/
export JAVA_HOME=/home/pub/jdk1.5.0_01/
export JFREECHART_HOME=
export PATH=${JACORB_HOME}/bin:${JAVA_HOME}/bin:${ANT_HOME}/bin:$PATH
export NS_PORT=47039

#For each command line parameter, executes the associated module
while [ "$1" !=  "" -o "$in" == "false" ]
do
   in=true
   case "$1" in
    "env")
    echo Done!
    shift
    ;;
    "servers")
      echo Initializing servers
      cd $JACORB_HOME/bin
      ./ns -DOAPort=$NS_PORT &
      cd $IG_HOME/clusterManagement/grm/launchTrader/
      ./settr &
      sleep $wait
      cd $IG_HOME/clusterManagement/grm/classes/
      ./runit &
      sleep $wait
      if [ ${secureAppRepos} = "true" ]
      then
	  cd $IG_HOME/clusterManagement/arsm/classes/
	  ./runit &
	  sleep $wait
      fi
      cd $IG_HOME/clusterManagement/applicationRepository/classes/
      ./runit &
      shift
    ;;
    "lrm")
      echo Initializing lrm
      sleep $wait
      cd $IG_HOME/resourceProviders/lrm
      ./LrmLauncher  &
      shift
    ;;
    "asctGui")
      echo Initializing asctGui
      cd $IG_HOME/tools/asctGui/classes
      ./runit &
      sleep $wait
      shift
    ;;
    "clusterview")
      cd $IG_HOME/tools/clusterView/classes
      ./runit &
      sleep $wait
      shift
    ;;
    "all")
      shift
      echo Initializing all
      . $0 env
      $0 servers
      $0 clusterview
      $0 lrm
      $0 asctGui
    ;;
    *)
      echo " "
      echo "Usage: $0 <lrm> <asct> <asctGui> <servers> <clusterview> <env> <all>"
      echo
      echo "env         -> Sets environment variables. Execute with a leading 'dot' (e.g.) . $0"
      echo "servers     -> Initializes server side modules(GRM and Application Repository)"
      echo "clusterview -> Initializes the graphical resource monitor"
      echo "lrm         -> Initializes the Local Resorce Manager"
      echo "asct        -> Initializes the Application submittion and Control tool"
      echo "asctGui     -> Initializes the Graphical Application submittion and Control tool"
      echo "all         -> Initializes all modules"
      echo
      shift
   esac
done





