package asctGui;
  //Class----------------------------------------------------------------------
  /**
    AppNameHolder - Holds an Application's name and path.

    @author Andrei Goldchleger
    @date February/2004

  */
  class AppNameHolder extends javax.swing.JLabel implements TooltipAble{

    //Fields------------------------------------------------------------------
    private String appPath_; /**< Local path to the registered application */
    private String appName_; /**< Filename of the registered application */
    private String appId_;   /**< Id of the registered application in the Application Repository */



    //Costructor--------------------------------------------------------------

    /**
      Creates a new AppNameHolder.

      @param appPath - Local path to the registered application
      @param appName - Filename of the registered application
      @param appId -  Id of the registered application in the Application Repository
    */
    AppNameHolder(String appPath, String appName, String appId){

      appPath_ = appPath;
      appName_ = appName;
      appId_ = appId;

    }

    //------------------------------------------------------------------------
    /**
      Overrides java.lang.Object method. Used to determine what is displayed by
      the JList that holds this object.
    */
    public String toString(){ return appName_; }

    public String appName(){ return appName_; }

    public String appId(){ return appId_; }

    public String appPath(){ return appPath_; }

    public String getToolTipText(){  return "AppPath: " + appPath_ + " AppReposId: " + appId_; }


  }//class
