package asctGui;
import java.io.File;
import java.util.HashMap;


  //Class----------------------------------------------------------------------
  /**
    DisplayExecHolder -

    @author Andrei Goldchleger
    @date February/2004

  */
  class DisplayExecHolder implements TooltipAble{

    //Fields------------------------------------------------------------------
    private String appPath_;
    private String requestId_;   /**< The id of the accepted execution */
    private int finishedNodes_;
    private HashMap subRequests_;
    private boolean collectedResults_;
    private int pendingSubRequests_;

    //Costructor--------------------------------------------------------------

    /**
      Creates a new DisplayExecHolder.
    */
    DisplayExecHolder(String appPath, String requestId){

    	
      appPath_ = appPath.substring(0,appPath.lastIndexOf("_"));
      requestId_ = requestId;
      finishedNodes_ = 0;
      subRequests_ = new HashMap();
      collectedResults_ = false;
      pendingSubRequests_ = 0;

    }

    //------------------------------------------------------------------------
    /**
      Overrides java.lang.Object method. Used to determine what is displayed by
      the JList that holds this object.
    */
    public String toString(){
      if(! appPath_.equals("")){
        if(! collectedResults_)
          return "<html><font color=#0000FF>" +  appName() + "</font>";
         else
          return "<html><font color=#00FF00>" +  appName() + "</font>";
      }
      else
        return "Unnamed app. RequestId: " + requestId_;
    }

    public void addSubRequest(String asctSubRequestId, RequestedExecHolder execHolder){

      subRequests_.put(asctSubRequestId, execHolder);
      pendingSubRequests_++;
    }

    public void fillSubRequest(String asctSubRequestId, String lrmIor, String lrmRequestId){

      RequestedExecHolder reqExecHolder = (RequestedExecHolder) subRequests_.get(asctSubRequestId);
      reqExecHolder.lrmIor(lrmIor);
      reqExecHolder.lrmRequestId(lrmRequestId);
      pendingSubRequests_--;
    }



    //Getters----------------------------------------------------------------
    public String appName(){ return (new File(appPath_)).getName(); }
    public String requestId(){ return requestId_; }
    public RequestedExecHolder [] subRequests(){
      RequestedExecHolder [] tmp = new RequestedExecHolder[subRequests_.size()];
      subRequests_.values().toArray(tmp);
      return tmp;
    }
    public String getToolTipText(){  return
               "Request Id: " + requestId_
              + " App Path: " + appPath_
              + " Status: " + (collectedResults_?"Finished":"Running"); }
    public boolean collectedResults(){ return collectedResults_; }
    public boolean allNodesFinished(){return finishedNodes_ == subRequests_.size(); }
    public boolean noPendingRequestsLeft(){ return (pendingSubRequests_ == 0); }

    public RequestedExecHolder getSubRequest(String subRequestId){
      return (RequestedExecHolder) subRequests_.get(subRequestId);
    }


    //Setters----------------------------------------------------------------
    public void nodeFinished(String asctSubRequestId) {
      ((RequestedExecHolder) subRequests_.get(asctSubRequestId)).finishedExecuting(true);
      finishedNodes_++;
    }

    public void collectedResults(boolean value){ collectedResults_ = value; }

  }//class
