package asctGui;
import javax.swing.JLabel;
import javax.swing.ListCellRenderer;
import javax.swing.DefaultListCellRenderer;

//For menus
import java.awt.event.MouseEvent;
import java.awt.event.MouseAdapter;
import javax.swing.JPopupMenu;
import javax.swing.JMenuItem;
import javax.swing.ListModel;
import javax.swing.JList;

//
import java.awt.Color;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.Component;

  class ExecutingApplicationsPanel extends ListPanel{



    ExecutingApplicationsPanel(String listName, Asct aAsct){
      super(listName);
      addListMouseListener(new ExecutingAppsMouseAdapter(aAsct));
    }

    //-----------------------------------------------------------------------
    public void removeElement (Object obj) {
      synchronized(appListModel){
        appListModel.removeElement(obj);
      }  
    }
  }//class


  //=========================================================================
  class ExecutingAppsMouseAdapter extends MouseAdapter{

    private Asct asct;

    ExecutingAppsMouseAdapter(Asct aAsct){ asct = aAsct; }

    //-----------------------------------------------------------------------
    public void mousePressed (MouseEvent e) {
      processMouseEvent(e);
    }

    //-----------------------------------------------------------------------
    public void mouseReleased (MouseEvent e) {
        processMouseEvent(e);

      }

    //-----------------------------------------------------------------------
    private void processMouseEvent(MouseEvent e){
       if(! e.isPopupTrigger())
         return;
       final JList execList = (JList) e.getComponent();
       final ListModel lm = execList.getModel();
       if(lm.getSize() == 0)
         return;
       final DisplayExecHolder selectedExec =
               (DisplayExecHolder)
                lm.getElementAt(execList.locationToIndex(e.getPoint()));
       execList.setSelectedIndex(execList.locationToIndex(e.getPoint()));
       if(selectedExec == null)
        return;


       JPopupMenu popup = new JPopupMenu ();
       if(selectedExec.collectedResults()){
         JMenuItem viewItem = new JMenuItem ("View Results");
         viewItem.addActionListener(new ActionListener(){
                   public void actionPerformed(ActionEvent e){
                      asct.viewResults();
                    }
                 });
         JMenuItem removeItem = new JMenuItem ("Remove Application");
         removeItem.addActionListener(new ActionListener(){
                   public void actionPerformed(ActionEvent e){
                      asct.removeApp(selectedExec.requestId());
                   }
                 });
         popup.add (viewItem);
         popup.add (removeItem);
       }
       else{
         JMenuItem killAppItem = new JMenuItem ("Kill Application");
       killAppItem.addActionListener(new ActionListener(){
                   public void actionPerformed(ActionEvent e){
                      asct.killApplication(selectedExec.requestId());

                   }
                 });
       popup.add (killAppItem);
       }
       popup.setInvoker (e.getComponent());
       popup.show (e.getComponent(), e.getX(), e.getY());
    }//Method
  }//class



